# Contributing

All contributions are welcome.

## Development

Fork, then clone the repo.

```bash
$ git clone https://github.com/{your-username}/react-redux.git
```

### Build

The build task will create a UMD build.

```bash
$ yarn build
```

### Test and Lint

To run tests:

```bash
$ yarn test
```

To continuously watch and run tests, run the following:

```bash
$ yarn test:watch
```

To perform linting with `eslint`, run the following:

```bash
$ yarn lint
```

## New Features

Please open an issue with a proposal for a new feature or refactoring before starting on the work.

## Submitting Changes

- Open a new issue.
- Fork the repo.
- Create a new feature branch based off the master branch.
- Make sure all tests pass and there are no linting errors.
- Submit a pull request, referencing any issues it addresses.
- Please try to keep your pull request focused in scope and avoid including unrelated commits.

Thank you for contributing!
